/**
 * xqueue.com
 */
package com.maileon.api.mailings.checks;

import java.io.Serializable;
import java.util.Date;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * Result object of Bounce Check
 */
@XmlRootElement(name="BounceCheck")
@XmlType(propOrder={"mailingId", "timestamp", "state", "totalContactCount",
    "sampleSize", "bounceCount", "bounceForcast", "bouceLimit"})
public class BounceCheckResult implements Serializable {

    private long mailingId;

    private String state;

    private Date timestamp;

    private int totalContactCount;

    private int sampleSize;

    private int bounceCount;

    private double bounceForcast;

    private double bouceLimit;

    @XmlElement
    public int getTotalContactCount() {
        return totalContactCount;
    }
    @XmlElement
    public int getSampleSize() {
        return sampleSize;
    }
    @XmlElement
    public int getBounceCount() {
        return bounceCount;
    }
    @XmlElement
    public double getBounceForcast() {
        return bounceForcast;
    }
    @XmlElement
    public double getBouceLimit() {
        return bouceLimit;
    }
    public void setTotalContactCount(int totalContactCount) {
        this.totalContactCount = totalContactCount;
    }
    public void setSampleSize(int sampleSize) {
        this.sampleSize = sampleSize;
    }
    public void setBounceCount(int bounceCount) {
        this.bounceCount = bounceCount;
    }
    public void setBounceForcast(double bounceForcast) {
        this.bounceForcast = bounceForcast;
    }
    public void setBouceLimit(double bouceLimit) {
        this.bouceLimit = bouceLimit;
    }

    @XmlElement
    public long getMailingId() {
        return mailingId;
    }

    public void setMailingId(long mailingId) {
        this.mailingId = mailingId;
    }

    @XmlElement
    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    @XmlElement
    public Date getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }

    @Override
    public String toString() {
        return "mailingId: " + mailingId
                + ", timestamp: " + timestamp
                + ", state: " + state
                + ", totalContactCount: " + totalContactCount
                + ", sampleSize: " + sampleSize
                + ", bounceCount: " + bounceCount
                + ", bounceForcast: " + bounceForcast
                + ", bouceLimit: " + bouceLimit;
    }
}
