package com.maileon.api.mailings.checks;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * Result information about Display check.
 */
@XmlRootElement(name="DisplayCheck")
@XmlType(propOrder = {"mailingId", "timestamp", "state", "desktopResults", "webResults", "mobileResults"})
public class DisplayCheckResult implements Serializable {

    private long mailingId;
    private Date timestamp;
    private String state;

    private List<DisplayCheckClientResult> desktopResults = new ArrayList<>();
    private List<DisplayCheckClientResult> mobileResults = new ArrayList<>();
    private List<DisplayCheckClientResult> webResults = new ArrayList<>();

    @XmlElement(name = "item", type=DisplayCheckClientResult.class)
    @XmlElementWrapper(name="desktop")
    public List<DisplayCheckClientResult> getDesktopResults() {
        return desktopResults;
    }

    public void setDesktopResults(List<DisplayCheckClientResult> desktopResults) {
        this.desktopResults = desktopResults;
    }

    @XmlElement(name = "item", type=DisplayCheckClientResult.class)
    @XmlElementWrapper(name="mobile")
    public List<DisplayCheckClientResult> getMobileResults() {
        return mobileResults;
    }

    public void setMobileResults(List<DisplayCheckClientResult> mobileResults) {
        this.mobileResults = mobileResults;
    }

    @XmlElement(name = "item", type=DisplayCheckClientResult.class)
    @XmlElementWrapper(name="web")
    public List<DisplayCheckClientResult> getWebResults() {
        return webResults;
    }

    public void setWebResults(List<DisplayCheckClientResult> webResults) {
        this.webResults = webResults;
    }

    @XmlElement
    public long getMailingId() {
        return mailingId;
    }

    public void setMailingId(long mailingId) {
        this.mailingId = mailingId;
    }

    @XmlElement
    public Date getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }

    @XmlElement
    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    @Override
    public String toString() {
        String ret = "mailingId: " + mailingId + ", state: " + state + ", timestamp: " + timestamp;
        ret += "\nDesktopResults{";
        for (DisplayCheckClientResult dcr : desktopResults)
            ret += dcr.toString() + ", ";
        ret += "}";
        ret += "\nMobileResults{";
        for (DisplayCheckClientResult dcr : mobileResults)
            ret += dcr.toString() + ", ";
        ret += "}";
        ret += "\nWebResults{";
        for (DisplayCheckClientResult dcr : webResults)
            ret += dcr.toString() + ", ";
        ret += "}";
        return ret;
    }
}
