package com.maileon.api.transactions;

import com.maileon.api.MaileonException;

/**
 * Created by mstaender on 09.07.2015.
 */
public class TransactionsTestUtils {
    public static long createTransactionType(MaileonTransactionsService service, String name) throws MaileonException {
        TransactionType type = new TransactionType();
        type.setName(name);
        service.createTransactionType(type);
        return service.findTransactionTypeByName(name).getId();
    }

    public static long createTransactionType(MaileonTransactionsService service, String name, int archivingDuration) throws MaileonException {
        TransactionType type = new TransactionType();
        type.setName(name);
        type.setArchivingDuration(archivingDuration);
        service.createTransactionType(type);
        return service.findTransactionTypeByName(name).getId();
    }

    public static long createTransactionType(MaileonTransactionsService service, String name, Object[][] attributes) throws MaileonException {
        TransactionType type = new TransactionType();
        type.setName(name);
        for (Object[] attribute : attributes) {
            Attribute newAttribute = new Attribute();
            newAttribute.setName((String) attribute[0]);
            newAttribute.setType((AttributeType) attribute[1]);
            if (attribute.length > 2) {
                newAttribute.setRequired((Boolean) attribute[2]);
            }
            type.getAttributes().add(newAttribute);
        }
        service.createTransactionType(type);
        return service.findTransactionTypeByName(name).getId();
    }
}
